% Money and Costly Credit, Mei Dong and Stella Huangfu, 2019
% Main program--this program calibrates the model using fminsearch;

clear all
global beta rho gamma A sigma k ii B gr irt md

%load the data which has nominal interest rates and money demand from
%1900-2000;
load data.txt
irt=data(:,2)/100;           %nominal interest rate;
md=data(:,3);                %money demand;

%Use fminsearch to find the solution that minimizes the sum of squared
%residuals;
y0=[0.08 0.4  1];                  %initial guess of (k,rho)
options=optimset('MaxFunEvals',100000,'TolFun',1e-10);
[y,fval,exitflag,output]=fminsearch(@crediteq_final,y0);
k=y(1);
rho=y(2);
B=y(3);
