% Mei Dong and Stella Huangfu, 2019
% use consumption equivalence for welfare measurement;

clear all
global rho gamma A B beta k ii sigma gr Wbench Wbenchk extra e0c e1c

beta=1/1.04;
rho=0.4733;      %strategy 1
gamma=1;
A=1;
B=1.4436;       %strategy 1
sigma=0.6321;
%k=0.0739;     %strategy 1
k=0.01;    %0.01-low k; 0.05-middle k; 0.1-high k 
%define some parameters for future use
gr=(2*gamma-rho)/(gamma-rho);
% load data.txt
% irt=data(70:100,2);
mm=1;
for ii=0.01:0.01:1;
%for ii=0.04
    %ii=irt(mm)/100;
    %k=kk(mm);
if ii<=0.07
x0=[0.8 0.9];
end

if ii>0.07
    x0=[0.1 0.3];
end
options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
%options=optimset('MaxFunEvals',1000,'TolFun',1e-10)
[x,fval,exitflag]=fsolve(@funcredit,x0,options);
%x
flags(mm)=exitflag;

e0(mm)=x(1);
e1(mm)=x(2);
q0(mm)=(x(1)/A)^(1/(gamma-rho));
q1(mm)=(x(2)/((1+ii)*A))^(1/(gamma-rho));
if e1(mm)>1 %| e1(mm)~=real(e1(mm));
    e1(mm)=1;
    x0=[0.5];
    options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
    %options=optimset('MaxFunEvals',1000,'TolFun',1e-10)
    [x,fval,exitflag]=fsolve(@funcredit2,x0,options);
    q0(mm)=x(1);
    e0(mm)=A/(x(1)^(rho-gamma));
end

e0c=e0(mm);
e1c=e1(mm);
rb0=A^(rho/(rho-gamma))/gamma*(1/gr)*e0(mm)^gr;
rb1=(A/gamma)*q0(mm)^gamma*(e1(mm)-e0(mm));
cq0(mm)=(A/gamma)*q0(mm)^gamma;
cq1(mm)=(A/gamma)*q1(mm)^gamma;
rb2=(A/gamma)*(A*(1+ii))^(gamma/(rho-gamma))*(1/gr)*(1-e1(mm)^gr);
rb(mm)=rb0+rb1+rb2;
outpc=B;
outp0=A^(1/(rho-gamma))*(gamma-rho)/(1+gamma-rho)*e0(mm)^((1+gamma-rho)/(gamma-rho));
outp1=(e1(mm)-e0(mm))*q0(mm);
outp2=((1+ii)*A)^(1/(rho-gamma))*(gamma-rho)/(1+gamma-rho)*(1-e1(mm)^((1+gamma-rho)/(gamma-rho)));
outp(mm)=outp0+outp1+outp2+rb(mm)+(1/beta-1)*(rb2-(1-e1(mm))*(A/gamma)*q0(mm)^gamma);
% output in units; notice that CM good and DM good are measure in different
% units;
toutp(mm)=sigma*outp(mm)+B;
outpc(mm)=sigma*(rb(mm)+(1/beta-1)*(rb2-(1-e1(mm))*cq0(mm)))+B;
outpd(mm)=sigma*rb(mm);
% output in terms of the CM goods;
toutp1(mm)=outpc(mm)+outpd(mm);
c2g(mm)=sigma*(rb2-(1-e1(mm))*cq0(mm))/toutp1(mm);
c2g1(mm)=sigma*(rb2-(1-e1(mm))*cq0(mm))/outpd(mm);
md(mm)=cq0(mm)+sigma*(1/beta)*(rb2-cq0(mm)*(1-e1(mm)));
% distortion in production associated with using credit;
extra=rb2-rb1/(e1(mm)-e0(mm))*(1-e1(mm));
W0u=(1/rho-1/gamma)*A^(rho/(rho-gamma))*(1/gr)*e0(mm)^gr;
W0c=(1/rho)*(e0(mm)/A)^(rho/(gamma-rho))*(1/2)*(e1(mm)^2-e0(mm)^2)-(A/gamma)*(e0(mm)/A)^(gamma/(gamma-rho))*(e1(mm)-e0(mm));
W1=A^(rho/(rho-gamma))*(1+ii)^(gamma/(rho-gamma))*((1+ii)/rho-1/gamma)*(1/gr)*(1-e1(mm)^gr);
% Welfare in a credit economy;
W(mm)=sigma*(W0u+W0c+W1-(1-e1(mm))*k)+B*log(B)-B-sigma*(1/beta-1)*(rb2-cq0(mm)*(1-e1(mm)));
Wbenchk=W(mm);
x0=[0.5];
options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
[x,fval,exitflag]=fsolve(@funwelk,x0,options);
cek(mm)=x;
% Welfare in a monetary economy;
x0=[0.5];
options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
[x,fval,exitflag]=fsolve(@funcredit2,x0,options);
qm(mm)=x(1);
em(mm)=A/(x(1)^(rho-gamma));
mdm(mm)=(A/gamma)*qm(mm)^gamma;
Wmu=(1/rho-1/gamma)*A^(rho/(rho-gamma))*(1/gr)*em(mm)^gr;
Wmc=(1/rho)*(em(mm)/A)^(rho/(gamma-rho))*(1/2)*(1-em(mm)^2)-(A/gamma)*(em(mm)/A)^(gamma/(gamma-rho))*(1-em(mm));
Wm(mm)=sigma*(Wmu+Wmc)+B*log(B)-B;
Wbench=Wm(mm);

%compute the consumption equivalence measure;
x0=[0.2];
options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
[x,fval,exitflag]=fsolve(@funwel,x0,options);
ce(mm)=x;
mm
mm=mm+1;
end

ii=0.01:0.01:1;
infl=100*((ii+1)/1.04-1);
figure(1)
subplot(1,2,1);plot(infl,c2g,'b','LineWidth',2);title('credit to GDP ratio','Fontsize',14);xlabel('inflation rate');ylabel('credit to GDP ratio');hold on
subplot(1,2,2);plot(infl,ce,'b','LineWidth',2);title('welfare improvement','Fontsize',14);xlabel('inflation rate');ylabel('consumption equivalence');hold on
% subplot(2,2,3);plot(infl,cek);hold on;
% subplot(2,2,4);plot(infl,toutp1);hold on;
% subplot(2,2,4);plot(infl,md);hold on;plot(infl,mdm,':');title('total money demand');xlabel('inflation rate');ylabel('money demand')

k=0.05;
mm=1;
for ii=0.01:0.01:1;
%for ii=0.04
    %ii=irt(mm)/100;
    %k=kk(mm);
if ii<=0.07
x0=[0.8 0.9];
end

if ii>0.07
    x0=[0.1 0.3];
end
options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
%options=optimset('MaxFunEvals',1000,'TolFun',1e-10)
[x,fval,exitflag]=fsolve(@funcredit,x0,options);
%x
flags(mm)=exitflag;

e0(mm)=x(1);
e1(mm)=x(2);
q0(mm)=(x(1)/A)^(1/(gamma-rho));
q1(mm)=(x(2)/((1+ii)*A))^(1/(gamma-rho));
if e1(mm)>1 %| e1(mm)~=real(e1(mm));
    e1(mm)=1;
    x0=[0.5];
    options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
    %options=optimset('MaxFunEvals',1000,'TolFun',1e-10)
    [x,fval,exitflag]=fsolve(@funcredit2,x0,options);
    q0(mm)=x(1);
    e0(mm)=A/(x(1)^(rho-gamma));
end

e0c=e0(mm);
e1c=e1(mm);
rb0=A^(rho/(rho-gamma))/gamma*(1/gr)*e0(mm)^gr;
rb1=(A/gamma)*q0(mm)^gamma*(e1(mm)-e0(mm));
cq0(mm)=(A/gamma)*q0(mm)^gamma;
cq1(mm)=(A/gamma)*q1(mm)^gamma;
rb2=(A/gamma)*(A*(1+ii))^(gamma/(rho-gamma))*(1/gr)*(1-e1(mm)^gr);
rb(mm)=rb0+rb1+rb2;
outpc=B;
outp0=A^(1/(rho-gamma))*(gamma-rho)/(1+gamma-rho)*e0(mm)^((1+gamma-rho)/(gamma-rho));
outp1=(e1(mm)-e0(mm))*q0(mm);
outp2=((1+ii)*A)^(1/(rho-gamma))*(gamma-rho)/(1+gamma-rho)*(1-e1(mm)^((1+gamma-rho)/(gamma-rho)));
outp(mm)=outp0+outp1+outp2+rb(mm)+(1/beta-1)*(rb2-(1-e1(mm))*(A/gamma)*q0(mm)^gamma);
% output in units; notice that CM good and DM good are measure in different
% units;
toutp(mm)=sigma*outp(mm)+B;
outpc(mm)=sigma*(rb(mm)+(1/beta-1)*(rb2-(1-e1(mm))*cq0(mm)))+B;
outpd(mm)=sigma*rb(mm);
% output in terms of the CM goods;
toutp1(mm)=outpc(mm)+outpd(mm);
c2g(mm)=sigma*(rb2-(1-e1(mm))*cq0(mm))/toutp1(mm);
c2g1(mm)=sigma*(rb2-(1-e1(mm))*cq0(mm))/outpd(mm);
md(mm)=cq0(mm)+sigma*(1/beta)*(rb2-cq0(mm)*(1-e1(mm)));
% distortion in production associated with using credit;
extra=rb2-rb1/(e1(mm)-e0(mm))*(1-e1(mm));
W0u=(1/rho-1/gamma)*A^(rho/(rho-gamma))*(1/gr)*e0(mm)^gr;
W0c=(1/rho)*(e0(mm)/A)^(rho/(gamma-rho))*(1/2)*(e1(mm)^2-e0(mm)^2)-(A/gamma)*(e0(mm)/A)^(gamma/(gamma-rho))*(e1(mm)-e0(mm));
W1=A^(rho/(rho-gamma))*(1+ii)^(gamma/(rho-gamma))*((1+ii)/rho-1/gamma)*(1/gr)*(1-e1(mm)^gr);
% Welfare in a credit economy;
W(mm)=sigma*(W0u+W0c+W1-(1-e1(mm))*k)+B*log(B)-B-sigma*(1/beta-1)*(rb2-cq0(mm)*(1-e1(mm)));
Wbenchk=W(mm);
x0=[0.5];
options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
[x,fval,exitflag]=fsolve(@funwelk,x0,options);
cek(mm)=x;
% Welfare in a monetary economy;
x0=[0.5];
options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
[x,fval,exitflag]=fsolve(@funcredit2,x0,options);
qm(mm)=x(1);
em(mm)=A/(x(1)^(rho-gamma));
mdm(mm)=(A/gamma)*qm(mm)^gamma;
Wmu=(1/rho-1/gamma)*A^(rho/(rho-gamma))*(1/gr)*em(mm)^gr;
Wmc=(1/rho)*(em(mm)/A)^(rho/(gamma-rho))*(1/2)*(1-em(mm)^2)-(A/gamma)*(em(mm)/A)^(gamma/(gamma-rho))*(1-em(mm));
Wm(mm)=sigma*(Wmu+Wmc)+B*log(B)-B;
Wbench=Wm(mm);

%compute the consumption equivalence measure;
x0=[0.2];
options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
[x,fval,exitflag]=fsolve(@funwel,x0,options);
ce(mm)=x;
mm
mm=mm+1;
end

subplot(1,2,1);plot(infl,c2g,'b:','LineWidth',2);title('credit to GDP ratio','Fontsize',14);xlabel('inflation rate');ylabel('credit to GDP ratio');hold on;
subplot(1,2,2);plot(infl,ce,'b:','LineWidth',2);title('welfare improvement','Fontsize',14);xlabel('inflation rate');ylabel('consumption equivalence');hold on;
% subplot(2,2,3);plot(infl,cek,':');hold on;
% subplot(2,2,4);plot(infl,toutp1,':');hold on;

k=0.1;
mm=1;
for ii=0.01:0.01:1;
%for ii=0.04
    %ii=irt(mm)/100;
    %k=kk(mm);
if ii<=0.07
x0=[0.8 0.9];
end

if ii>0.07
    x0=[0.1 0.3];
end
options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
%options=optimset('MaxFunEvals',1000,'TolFun',1e-10)
[x,fval,exitflag]=fsolve(@funcredit,x0,options);
%x
flags(mm)=exitflag;

e0(mm)=x(1);
e1(mm)=x(2);
q0(mm)=(x(1)/A)^(1/(gamma-rho));
q1(mm)=(x(2)/((1+ii)*A))^(1/(gamma-rho));
if e1(mm)>1 %| e1(mm)~=real(e1(mm));
    e1(mm)=1;
    x0=[0.5];
    options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
    %options=optimset('MaxFunEvals',1000,'TolFun',1e-10)
    [x,fval,exitflag]=fsolve(@funcredit2,x0,options);
    q0(mm)=x(1);
    e0(mm)=A/(x(1)^(rho-gamma));
end

e0c=e0(mm);
e1c=e1(mm);
rb0=A^(rho/(rho-gamma))/gamma*(1/gr)*e0(mm)^gr;
rb1=(A/gamma)*q0(mm)^gamma*(e1(mm)-e0(mm));
cq0(mm)=(A/gamma)*q0(mm)^gamma;
cq1(mm)=(A/gamma)*q1(mm)^gamma;
rb2=(A/gamma)*(A*(1+ii))^(gamma/(rho-gamma))*(1/gr)*(1-e1(mm)^gr);
rb(mm)=rb0+rb1+rb2;
outpc=B;
outp0=A^(1/(rho-gamma))*(gamma-rho)/(1+gamma-rho)*e0(mm)^((1+gamma-rho)/(gamma-rho));
outp1=(e1(mm)-e0(mm))*q0(mm);
outp2=((1+ii)*A)^(1/(rho-gamma))*(gamma-rho)/(1+gamma-rho)*(1-e1(mm)^((1+gamma-rho)/(gamma-rho)));
outp(mm)=outp0+outp1+outp2+rb(mm)+(1/beta-1)*(rb2-(1-e1(mm))*(A/gamma)*q0(mm)^gamma);
% output in units; notice that CM good and DM good are measure in different
% units;
toutp(mm)=sigma*outp(mm)+B;
outpc(mm)=sigma*(rb(mm)+(1/beta-1)*(rb2-(1-e1(mm))*cq0(mm)))+B;
outpd(mm)=sigma*rb(mm);
% output in terms of the CM goods;
toutp1(mm)=outpc(mm)+outpd(mm);
c2g(mm)=sigma*(rb2-(1-e1(mm))*cq0(mm))/toutp1(mm);
c2g1(mm)=sigma*(rb2-(1-e1(mm))*cq0(mm))/outpd(mm);
md(mm)=cq0(mm)+sigma*(1/beta)*(rb2-cq0(mm)*(1-e1(mm)));
% distortion in production associated with using credit;
extra=rb2-rb1/(e1(mm)-e0(mm))*(1-e1(mm));
W0u=(1/rho-1/gamma)*A^(rho/(rho-gamma))*(1/gr)*e0(mm)^gr;
W0c=(1/rho)*(e0(mm)/A)^(rho/(gamma-rho))*(1/2)*(e1(mm)^2-e0(mm)^2)-(A/gamma)*(e0(mm)/A)^(gamma/(gamma-rho))*(e1(mm)-e0(mm));
W1=A^(rho/(rho-gamma))*(1+ii)^(gamma/(rho-gamma))*((1+ii)/rho-1/gamma)*(1/gr)*(1-e1(mm)^gr);
% Welfare in a credit economy;
W(mm)=sigma*(W0u+W0c+W1-(1-e1(mm))*k)+B*log(B)-B-sigma*(1/beta-1)*(rb2-cq0(mm)*(1-e1(mm)));
Wbenchk=W(mm);
x0=[0.5];
options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
[x,fval,exitflag]=fsolve(@funwelk,x0,options);
cek(mm)=x;
% Welfare in a monetary economy;
x0=[0.5];
options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
[x,fval,exitflag]=fsolve(@funcredit2,x0,options);
qm(mm)=x(1);
em(mm)=A/(x(1)^(rho-gamma));
mdm(mm)=(A/gamma)*qm(mm)^gamma;
Wmu=(1/rho-1/gamma)*A^(rho/(rho-gamma))*(1/gr)*em(mm)^gr;
Wmc=(1/rho)*(em(mm)/A)^(rho/(gamma-rho))*(1/2)*(1-em(mm)^2)-(A/gamma)*(em(mm)/A)^(gamma/(gamma-rho))*(1-em(mm));
Wm(mm)=sigma*(Wmu+Wmc)+B*log(B)-B;
Wbench=Wm(mm);

%compute the consumption equivalence measure;
x0=[0.2];
options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
[x,fval,exitflag]=fsolve(@funwel,x0,options);
ce(mm)=x;
mm
mm=mm+1;
end

subplot(1,2,1);plot(infl,c2g,'b--','LineWidth',2);title('credit to GDP ratio','FontSize',14);xlabel('inflation rate');ylabel('credit to GDP ratio');axis([-5 100 0 0.11]);legend('k=0.01','k=0.05','k=0.1','Location','southeast')
subplot(1,2,2);plot(infl,ce,'b--','LineWidth',2);title('welfare improvement','FontSize',14);xlabel('inflation rate');ylabel('consumption equivalence');axis([-5 100 -0.008 0.035]);legend('k=0.01','k=0.05','k=0.1','Location','southeast')
% subplot(2,2,3);plot(infl,cek,'--')
% subplot(2,2,4);plot(infl,toutp1,'--')

