% function that define the nonlinear least square's objective without using
% symbolic toolbox;

function G=crediteq_final(y);

global beta rho gamma A sigma k ii B irt md

beta=1/1.04;
%beta=0.99;                 %quarterly data
gamma=1;
A=1;
sigma=0.6321;
k=y(1);
%k=0.0739;
rho=y(2);
B=y(3);
gr=(2*gamma-rho)/(gamma-rho);
%solve for equlibrium (q0,q1);
nn=length(irt);
for j=1:nn;
    ii=irt(j);
    if ii<=0.07
        x0=[0.8 0.9];
    else
    x0=[0.1 0.3];
    end
    options=optimset('MaxFunEvals',1000,'TolFun',1e-20,'Display','off');
    [x,fval,exitflag]=fsolve(@funcredit,x0,options);
    flags(j)=exitflag; 
    e0(j)=x(1);
    e1(j)=x(2);
    q0(j)=(x(1)/A)^(1/(gamma-rho));
    q1(j)=(x(2)/((1+ii)*A))^(1/(gamma-rho));
   %e1(j)=2;
    if e1(j)>1 || e1(j)~=real(e1(j))
        e1(j)=1;
        x0=[0.2];
        options=optimset('MaxFunEvals',100000,'MaxIter',100000,'TolFun',1e-10,'Display','off');
        %options=optimset('MaxFunEvals',1000,'TolFun',1e-10)
        [x,fval,exitflag]=fsolve(@funcredit2,x0,options);
        q0(j)=x(1);
        e0(j)=A/(x(1)^(rho-gamma));
    end
    rb0=A^(rho/(rho-gamma))/gamma*(1/gr)*e0(j)^gr;
    rb1=(A/gamma)*q0(j)^gamma*(e1(j)-e0(j));
    rb2=(A/gamma)*(A*(1+ii))^(gamma/(rho-gamma))*(1/gr)*(1-e1(j)^gr);
    rb(j)=rb0+rb1+rb2;
    outpb=B;
    outpc(j)=sigma*(rb(j)+(1/beta-1)*(rb2-(1-e1(j))*(A/gamma)*q0(j)^gamma))+B;
    outpd(j)=sigma*rb(j);
    toutp(j)=outpc(j)+outpd(j);

    g(j)=(rb1/(e1(j)-e0(j))+sigma/beta*(rb2-rb1*(1-e1(j))/(e1(j)-e0(j))))/toutp(j);
end 
G=(md'-g)*(md-g')

save fitted g;
